#ifndef _AUDIOMENU_H_
#define _AUDIOMENU_H_
#include "Menu.h"
#include "TrebleSlider.h"
#include "BassSlider.h"
#include "BalanceSlider.h"
#include "VolumeSlider.h"
#include "ContrastSlider.h"
#include "RioAudio.h"

class AudioMenu : public Menu
{
public:
    AudioMenu (RioAudio *audio, Window *parent, const char *name="Audio Menu");
    void volumeWindow ();

private:
    void randomFunc (Line *line);
    void menuBack (Line *line);
    void menuTreble (Line *line);
    void menuBass (Line *line);
    void menuBalance (Line *line);
    void menuVolume (Line *line);
    void menuContrast (Line *line);

private:
    TrebleSlider *treble;
    BassSlider *bass;
    BalanceSlider *balance;
    VolumeSlider *volume;
    ContrastSlider *contrast;
    RioAudio *audio;
};
#endif // _AUDIOMENU_H_
