#include <iostream>
#include "BassSlider.h"

BassSlider::BassSlider (RioAudio *audio, Window *parent, const char *name)
    : Slider (0, 100, 0, 5, "-", "+", parent, true, name)
{
    this->audio = audio;
    int lvl = audio->getBass();

    if (!audio || lvl < 0) { /* feature not implemented on output device */
        disable();
    } else {
        setCur (lvl);
    }
}

void
BassSlider::update (double val)
{
    cerr << "BassSlider::updated (" << val << ")" << endl;
    int lvl = (int) val;
    audio->setBass (lvl);
}
