#include <iostream>
#include <sys/ioctl.h>
#include "ContrastSlider.h"

ContrastSlider::ContrastSlider (RioAudio *audio, Window *parent, const char *name)
    : Slider (0, 20, 10, 1, "light", "dark", parent, true, name)
{
    this->audio = audio;
    setCur (USER_CONTRAST_VALUE(display->getContrast()));
}

void
ContrastSlider::update (double val)
{
    int lvl = (7<<6) + (int)val + 19;
    cerr << "Slider setting contrast using level " << lvl << endl; 
    display->setContrast (lvl);
}
