#ifndef _DISPLAYDEV_H_
#define _DISPLAYDEV_H_
#include <stdio.h>
#include <pthread.h>

#define DEFAULT_CONTRAST_VALUE (7<<6) + (/* The user visible value */ 9) + 19
#define USER_CONTRAST_VALUE(x) ((x) - (7<<6) - 19)

class DisplayDev
{
public:
    DisplayDev (int rows, int cols, int memsize);

public: // display control
    virtual void setContrast (int lvl) {};
    virtual int  getContrast (void) { return -1; };

    virtual void setBacklight (int lvl) {};
    virtual int  getBacklight (void) { return -1; };

    virtual void setPower (bool on) {};
    virtual void refresh (void) {};        // Updates the display output

public:
    int rows (void) { return _rows; };
    int cols (void) { return _cols; };
    int memsize (void) { return _memsize; };
    void writeToScreen (const char *data, int size);
    void lock (void);
    void unlock (void);

protected:
    char *mem;                          // Memory mapped to the display

private:
    pthread_mutex_t _lock;              // Screenlock
    int _rows;
    int _cols;
    int _memsize;
};
#endif // _DISPLAYDEV_H_
