#ifndef _SLIDER_H_
#define _SLIDER_H_
#include "Window.h"
class Slider : public Window
{
public:
    Slider (double low, double high, double start, double increment,
            const char *low_tag, const char *high_tag,
            Window *parent, bool show_center=false,
            const char *name="Generic Slider");

private:
    void draw (void);
    void draw_disabled (void);
    void draw_labels (void);
    bool _onMenuButton (bool pushedAgain=false);
    bool _onKnobButton (bool pushedAgain=false);
    bool _onKnobLeft (bool pushedAgain=false);
    bool _onKnobRight (bool pushedAgain=false);
    virtual void update (double val);
    void inFocus (void);
    void outFocus (void);

protected:
    void setCur (double cur);
    void enable (void);
    void disable (void);

private:
    double _cur;
    double _increment;
    double _range;
    double _high;
    double _low;
    int _positions;
    int slider_width;
    int slider_x;
    bool _show_center;
    bool enabled;
    const char *_high_tag;
    const char *_low_tag;
};
#endif // _SLIDER_H_
