#include <iostream>
#include "TrebleSlider.h"

TrebleSlider::TrebleSlider (RioAudio *audio, Window *parent, const char *name)
    : Slider (0, 100, 0, 5, "-", "+", parent, true, name)
{
    this->audio = audio;
    if (audio) {
        int lvl = audio->getTreble();
        if (lvl >=  0) /* feature not implemented on output device */
            setCur (lvl);
        else
            disable ();
    } else {
        disable ();
    }
}

void
TrebleSlider::update (double val)
{
    cerr << "TrebleSlider::updated (" << val << ")" << endl;
    int lvl = (int) val;
    audio->setTreble (lvl);
}
