#include <qwidget.h>
#include <qsize.h>
#include <qpainter.h>
#include <qsocket.h>
#include <sys/types.h>
#include <stdint.h>
#include <qcolor.h>
#include "UnixServerSocket.h"

#define BGCOLOR_BACKLIGHT_OFF "#909b9d"
#define BGCOLOR_BACKLIGHT_ON  "#81bcc6"
#define FGCOLOR_BACKLIGHT_OFF "#000000"
#define FGCOLOR_BACKLIGHT_ON  "#096f7a"
#define DEFAULT_CONTRAST_VALUE (7<<6) + (/* The user visible value */ 9) + 19
#define USER_CONTRAST_VALUE(x) ((x) - (7<<6) - 19)
class XRioScreen : public QWidget
{
public:
    XRioScreen (int x, int y, QWidget *parent = 0,
                const char *name = 0, WFlags f = 0);
    ~XRioScreen();
    void paintEvent (QPaintEvent *);
    void resizeEvent (const QSize &size, const QSize &oldsize);
    void update (char *newscreen, int size);

public: // Control methods
    void setContrastLevel (int lvl);
    int getContrastLevel (void);
    void setBacklightLevel (int lvl);
    int getBacklightLevel (void);
    void setPower (bool state);

private:
    QSocket *newConn (int sock);
    QColor cfgColor; // Color at center contrast
    QColor cbgColor; // Color at center contrast
    QColor fgColor;
    QColor bgColor;
    void irOut (uint32_t val);
    int _width, _height, _scale, _memsize;
    char *mem;
    void drawScaledPixel (QPainter &screen, int scale, int x, int y);
    int contrastTransform (QColor &color, int lvl);
    int offX;
    int offY;

    int _contrast;
    int _backlight;
};



