#include <qapplication.h>
#include <qstring.h>
#include <iostream>
#include "XRio.h"

int
main (int argc, char *argv[])
{
    QApplication qapp (argc, argv);
    XRio *rio;
    try {
        rio = new XRio ("display", "display.ctl", "irport");
    } catch (QString str) {
        cerr << str << endl;
        exit (1);
    } catch (const char *str) {
        cerr << str << endl;
        exit (1);
    } catch (...) {
        cerr << "Error occured while initializing XRio" << endl;
        exit (1);
    }

    qapp.setMainWidget (rio);
    rio->show ();

    qapp.connect ( &qapp, SIGNAL (lastWindowClosed()), &qapp, SLOT (quit()));

    return qapp.exec ();
}
