#include <stdio.h>
#include <unistd.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <sys/fcntl.h>
#include <string.h>
#include <sys/types.h>
#include <sys/fcntl.h>
#include <linux/reboot.h>
#include <pthread.h>
#include <sys/socket.h>
#include <linux/un.h>
#include <sys/ioctl.h>

#define DEFAULT_HOST "129.21.2.93"
#define PORT 8000

int
setup_console (void)
{
    int fd;
    struct sockaddr_in sin;
    char *host = DEFAULT_HOST;
    int using_default = 0;

    fd = open ("/proc/cmdline", O_RDONLY);
    if (fd >= 0) {
        char buf[100];
        char *host, *p2;
        if (read (fd, buf, sizeof (buf)) < 0) {
            using_default = 1;
            goto failed;
        }

        host = strstr (buf, "ip=");
        if (!host) {
            host = DEFAULT_HOST;
            using_default = 1;
            goto failed;
        }

        host = strstr (host, ":");
        if (!host) {
            host = DEFAULT_HOST;
            using_default = 1;
            goto failed;
        }

        p2 = strstr (host, ":");
        if (!p2) {
            host = DEFAULT_HOST;
            using_default = 1;
            goto failed;
        }
        *p2 = 0;

        failed:
        close (fd);
    }

    inet_aton (host, &sin.sin_addr);

    fd = socket (PF_INET, SOCK_STREAM, IPPROTO_TCP);
    if (fd < 0) {
        return -1;
    }

    sin.sin_family = AF_INET;
    sin.sin_port = htons (PORT);

    if (connect (fd, (struct sockaddr *)&sin, sizeof (sin)) < 0) {
        return -1;
    }

    if (dup2 (fd, STDOUT_FILENO) < 0) {
        close (fd);
        return -1;
    }

    if (dup2 (fd, STDERR_FILENO) < 0) {
        close (fd);
        return -1;
    }

    if (using_default) {
        printf ("WARNING: Using default host for console\n");
    }

    return 0;
}
